---
cluster: "dcc"
form:
  - custom_account
  - custom_queue
  - bc_num_hours
  - bc_num_slots
  - num_cpus
  - num_mem
  - num_gpus
  - email
  - addargs
  - datacommons
  - externalnfs
  - singularity_img
submit: submit.yml.erb
id: submitForm
name : submitForm
title: RStudio Singularity
attributes:
  custom_account:
    id: custom_account
    label: Account
    widget: select
    cacheable: true
    help: |
    <%- if CustomAccounts.accounts.blank?-%>   
      <div class="text-danger">Error while fetching Account. Please contact support!</div>
    <%- else -%>
    options:
    <%- CustomAccounts.accounts.each do |q| -%>
      - [ "<%= q %>", "<%= q %>" ]
    <%- end -%>
    <%- end -%>
  custom_queue:
    id: custom_queue
    label: Partition
    widget: select
    cacheable: true
    help: |
    <%- if CustomQueues.queues.blank?-%>   
      <div class="text-danger">Error while fetching Partition. Please contact support!</div>
    <%- else -%>
      The partition you select has to allow jobs from the account you select.
    options:
    <%- CustomQueues.queues.each do |q| -%>
      - [ "<%= q %>", "<%= q %>" ]
    <%- end -%>
    <%- end -%>
  bc_num_hours:
    id: bc_num_hours
    label: Walltime (Hours)
    help: |
      - Number of hours to allocate
      - Exceeding walltime time will automaticaly stop this job.
    cacheable: true
    widget: number_field
    max: 168
    min: 1
    step: 1
    value: 1
  bc_num_slots: 1
  num_cpus:
    id: num_cpus
    label: CPUs (Threads)
    help: Number of CPU threads
    cacheable: true
    widget: number_field
    max: 40
    min: 2
    step: 2
    value: 2
  num_mem:
    id: num_mem
    label: Memory (GB/Gigabytes)
    help: Total memory is available to all assigned threads!
    cacheable: true
    widget: number_field
    max: 208
    min: 1
    step: 1
    value: 2
  num_gpus:
    id: num_gpus
    label: "GPUs"
    help: "Number of GPU or CUDA devices. You should also have selected a partition that has GPU nodes. Most GPU nodes only have 1 GPU assigned to them."
    cacheable: false
    widget: number_field
    max: 2
    min: 0
    step: 1
    value: 0
  email:
    id: email
    label: Email Address
    help: |
      Enter your email address if you would like to receive job notifications (start, finished, failed, etc..).  Otherwise, leave the field empty.

      --------------------------
    cacheable: true
    widget: text_field
  addargs:
    widget: "text_field"
    id: addargs
    label: "Additional Slurm arguments"
    help: "Any additional Slurm parameters e.g. -w dcc-core-01"
  # If a datacommons mount will be needed in the RStudio Singularity container it will need to be bind
  # mounted in. Allow user to specify the datacommons mount or leave blank.
  datacommons:
    widget: "text_field"
    id: datacommons
    label: "Datacommons mount"
    help: |
      Datacommons mount if it will be used in RStudio. e.g. dhvi for /datacommons/dhvi.
      Leave field empty otherwise.
  # If an external NFS mount will be needed in the RStudio Singularity container it will need to be bind
  # mounted in. Allow user to specify the NFS mount under /nfs or leave blank.
  externalnfs:
    widget: "text_field"
    id: externalnfs
    label: "Mount under /nfs"
    help: |
      If you have purchased an NFS share from the storage team, requested it be mounted in the DCC, and wish
      to access it in RStudio then enter the share name here. Leave off the /nfs portion and just enter the name.
  singularity_img:
    id: singularity_img
    label: Singularity Container File
    help: |
      Select a Singularity Container (.sif/.simg) that includes R and RStudio Server version 1.4 or higher.
      [DCC web page with list of available RStudio Singularity images](https://dcc.duke.edu/OpenOnDemand/RStudio/)
    cacheable: false
    data-filepicker: true
    data-target-file-type: files
    data-target-file-pattern: '(.simg|.sif)$'
    data-file_picker_favorites: '[{"title": "/opt/apps/containers/community", "href": "/opt/apps/containers/community"},
                                  {"title": "/opt/apps/containers/oit", "href": "/opt/apps/containers/oit"},
                                  {"title": "/opt/apps/community", "href": "/opt/apps/community"},
                                  {"title": "/work", "href": "/work"}
                                ]'
    data-default-directory: '/opt/apps/containers/oit/rstudio'
    readonly: false
    value: '/opt/apps/containers/oit/rstudio/ondemand_bioconductor.sif'
